#include <windows.h>
#include "antlock.h"

void ant_init(ant_lock *lock)
{
	lock->h_event = CreateEvent(NULL, TRUE, TRUE, NULL);
	lock->h_mutex = CreateMutex(NULL, FALSE, NULL);
	lock->count   = 0;
}

void ant_lock_shared(ant_lock *lock)
{
	WaitForSingleObject(lock->h_mutex, INFINITE);
	ResetEvent(lock->h_event);
	++lock->count;
	ReleaseMutex(lock->h_mutex);
}

void ant_unlock_shared(ant_lock *lock)
{
	WaitForSingleObject(lock->h_mutex, INFINITE);

	if (--lock->count == 0) {
		SetEvent(lock->h_event);
	}
	ReleaseMutex(lock->h_mutex);
}

void ant_lock_exclusive(ant_lock *lock)
{
again:;
	WaitForSingleObject(lock->h_event, INFINITE);
	WaitForSingleObject(lock->h_mutex, INFINITE);

	if (lock->count != 0) {
		ReleaseMutex(lock->h_mutex);
		goto again;
	}
}

void ant_unlock_exclusive(ant_lock *lock)
{
	ReleaseMutex(lock->h_mutex);
}